"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
const schemes_1 = __importDefault(require("./schemes"));
const express_1 = __importDefault(require("express"));
const path_1 = __importDefault(require("path"));
const index_1 = require("./index");
const config_1 = __importDefault(require("./config"));
const operator = express_1.default.Router();
operator.route('/getConfig').get((req, res, next) => {
    res.json({ success: true, data: config_1.default.baseConfig });
});
operator.route('/getSchemes').get((req, res, next) => {
    res.json({ success: true, data: schemes_1.default });
});
operator.route('/getPaths').post((req, res, next) => {
    try {
        const params = req.body;
        res.json({ success: false, data: (0, utils_1.getFolders)(path_1.default.resolve(params.path)) });
    }
    catch (error) {
        res.json({ success: false, data: null, message: error });
    }
});
operator.route("/getItem").post((req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    try {
        const params = req.body;
        var getItem = yield index_1.wdClient.getItems([params.itemID]);
        if (getItem.success == false || getItem.data.length <= 0) {
            res.json(getItem);
            return;
        }
        var item = getItem.data[0];
        var fetchedItems = [];
        if (item.file_type != 2) {
            fetchedItems.push(item);
        }
        var lookIDS = (_a = item.children) === null || _a === void 0 ? void 0 : _a.map(x => x.publishedfileid);
        if (lookIDS != null && lookIDS.length > 0) {
            var getDeps = yield (0, utils_1.getAllDepIDS)(index_1.wdClient, lookIDS);
            fetchedItems = fetchedItems.concat(getDeps.Items);
        }
        res.json({ success: true, data: fetchedItems });
    }
    catch (error) {
        res.json({ success: false, data: null, message: error });
    }
}));
exports.default = operator;
