"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.execute = void 0;
const path_1 = __importDefault(require("path"));
const utils_1 = require("./utils");
const schemes_1 = __importDefault(require("./schemes"));
const execute = (basePath, schemes, params) => {
    let executeAll = (scheme, myscheme) => {
        if (myscheme.childs && myscheme.childs.length > 0) {
            if (scheme.execute(myscheme.params.map((x) => {
                let rpath = x.value;
                if (!path_1.default.isAbsolute(x.value)) {
                    rpath = path_1.default.join(basePath, rpath);
                }
                if (myscheme.id == 0) {
                    if (!(0, utils_1.isRelative)(basePath, rpath)) {
                        throw 'You can just delete sub folder of main workshop folder';
                    }
                }
                return (0, utils_1.writeParams)(rpath, params);
            })) === true) {
                (myscheme.childs).forEach(singleChild => {
                    var bul = schemes_1.default.find(x => x.id == singleChild.id);
                    if (bul != null)
                        executeAll(bul, singleChild);
                });
            }
        }
        else {
            scheme.execute(myscheme.params.map((x) => {
                let rpath = x.value;
                if (!path_1.default.isAbsolute(x.value)) {
                    rpath = path_1.default.join(basePath, rpath);
                }
                if (myscheme.id == 0) {
                    if (!(0, utils_1.isRelative)(basePath, rpath)) {
                        throw 'You can just delete sub folder of main workshop folder';
                    }
                }
                return (0, utils_1.writeParams)(rpath, params);
            }));
        }
    };
    schemes.forEach(SingleScheme => {
        var find = schemes_1.default.find(x => x.id == SingleScheme.id);
        if (find)
            executeAll(find, SingleScheme);
    });
};
exports.execute = execute;
